#lang racket

(define target 2020)

; Better file reading somehow?
(define (read-expenses file)
  (current-input-port (open-input-file file #:mode 'text))
  (do ([expense (read-line) (read-line)]
       [expenses (set) (set-add expenses (string->number expense))])
    ((eof-object? expense) expenses)
    #t
    ))

; Would be best if it bailed when it finds solution
(define (find-2sum expenses)
  (for/list ([expense (in-set expenses)]
             #:when (set-member? expenses (- target expense)))
    expense))

(define expenses (read-expenses "input"))
(displayln  expenses)
(let ([magic (find-2sum expenses)])
  (displayln magic)
  (displayln (* (first magic) (second magic))))

